/*!
 * @file media_container.h
  *  Manages the media files

*/

#ifndef _MEDIA_CONTAINER
#define _MEDIA_CONTAINER


#ifdef HAVE_AVFORMAT_H
  #include <avformat.h>
#else
  #include <ffmpeg/avformat.h>
#endif


#include "glincl.h"

/* include base_object.h since all classes are derived from this one */
#include "base_object.h"

/* using namespace std is default, this needs to be here */
using namespace std;

/* Forward Declaration */
struct SDL_Surface;

class MediaContainer : public BaseObject
{

private:

	int current_frame;
	int num_frames;

	AVFormatContext* format_context;
	AVCodecContext* codec_context;
	AVCodec* codec;
	AVFrame* frame;
	AVPacket packet;
	
	int num_bytes;
	int video_stream;
	bool frames_left;

public:

  MediaContainer(const char* filename);
  ~MediaContainer();

	//GLuint getFrame(int frame_number);
	SDL_Surface* getFrame(int frame_number);
	//GLuint getNextFrame();
	SDL_Surface* getNextFrame();
	void loadMedia(const char* filename);
	
	int getHeight();
	int getWidth();
	int getFrameRate();
	void getStream(/* stream */);

	bool framesLeft();

	/* prints some information about the
	   media file for debug reasons */
	void printMediaInformation();

};



#endif /* _MEDIA_CONTAINER */
